/*********************************************
This program was produced by the
CodeWizardAVR V1.24.0 Standard
Automatic Program Generator
 Copyright 1998-2003 HP InfoTech s.r.l.
http://www.hpinfotech.ro
e-mail:office@hpinfotech.ro

Project : Gestion d'un systme d'aspiration de copeaux
Version : V1
Date    : 03/07/2005
Author  : Philippe MARIANO  (phil-mariano@infonie.fr)                     
Company : PE MARTIN 1, Avenue de Gionne 18000 BOURGES                                
Comments: TP1 Logique sur carte SSI


Chip type           : Mega8535
Clock frequency     : 8,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 128
*********************************************/

#include <mega8535.h>
#include <ssi.h>	// Contient la fonction AfficheLCD()
#include <stdio.h>
#include <delay.h>


// Alphanumeric LCD Module functions
#asm
   .equ __lcd_port=0x15
#endasm
#include <lcd.h>

//outputs
#define P1  PORTB.0
#define D1  PORTB.1

//inputs
#define P2  !PINA.5
#define P3  !PINA.3
#define P4  !PINA.4
#define TP  !PINA.1
#define P   !PINA.1
#define M1  !PINA.0
#define A1  PINA.2

// Declare your global variables here 
/*-----------------------------------------------------------------------------------------
type 		nom 				       		dsignation       
------------------------------------------------------------------------------------------*/
bit X; 
bit Set; 
bit Reset;


void main(void)
{
// Declare your local variables here  
/*-----------------------------------------------------------------------------------------
type 		nom 				       		dsignation       
------------------------------------------------------------------------------------------*/
char display_buffer_ligne0[17]; 			// tampon ligne 0 de l'afficheur
char display_buffer_ligne1[17]; 	       		// tampon ligne 1 de l'afficheur  
unsigned char Aff=0, Aff_1=0;

// Input/Output Ports initialization
// Port A initialization
PORTA=0x3F; 		// ne pas modifier cette valeur
DDRA=0x00;  		// 

// Port B initialization
PORTB=0x00;
DDRB=0xff;


// LCD module initialization
lcd_init(16);

sprintf(display_buffer_ligne0,"---Aspiration---");
sprintf(display_buffer_ligne1,"   de Copeaux   ");
Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
delay_ms(3000);
sprintf(display_buffer_ligne0,"Postes en fonct.");

while (1)
      {
       D1 = (X | TP | P) & M1;		
       X =  (P2&P3) | (P2&P4) | (P3&P4);  //(P1&P2) | (P1&P3) | (P1&P4)  
       Set = !X & M1;
       Reset = !A1 | TP |P;
       P1 = (P1 | Set) & !Reset; 
       
       if(TP){sprintf(display_buffer_ligne1,"Tremie pleine   ");Aff=12;} // doit tre prioritaire
       else if (P1&P2){sprintf(display_buffer_ligne1,"Poste1 et Poste2");Aff=1;}
       else if (P1&P3){sprintf(display_buffer_ligne1,"Poste1 et Poste3");Aff=2;}
       else if (P1&P4){sprintf(display_buffer_ligne1,"Poste1 et Poste4");Aff=3;}
       else if (P2&P3){sprintf(display_buffer_ligne1,"Poste2 et Poste3");Aff=4;}
       else if (P2&P4){sprintf(display_buffer_ligne1,"Poste2 et Poste4");Aff=5;} 
       else if (P3&P4){sprintf(display_buffer_ligne1,"Poste3 et Poste4");Aff=6;}
       else if(P1&!P2&!P3&!P4){sprintf(display_buffer_ligne1,"Poste 1         ");Aff=7;} 
       else if(!P1&P2&!P3&!P4){sprintf(display_buffer_ligne1,"Poste 2         ");Aff=8;}
       else if(!P1&!P2&P3&!P4){sprintf(display_buffer_ligne1,"Poste 3         ");Aff=9;}
       else if(!P1&!P2&!P3&P4){sprintf(display_buffer_ligne1,"Poste 4         ");Aff=10;}
       else if(!P1&!P2&!P3&!P4){sprintf(display_buffer_ligne1,"Aucun           ");Aff=11;} 
        		 			
        						 
       if (Aff != Aff_1) {Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);Aff_1=Aff;}
      };
}
